/* ---------------------------------------------------------------------------

Copyright (C) 1990, 1991, 1993, 1994, 2002.

A. Ronald Gallant
Post Office Box 659 
Chapel Hill NC 27514-0659 
USA   

Permission to use, copy, modify, and distribute this software and its 
documentation for any purpose and without fee is hereby granted, provided 
that the above copyright notice appears in all copies and that both that 
copyright notice and this permission notice appear in supporting 
documentation.  

This software is provided "as is" without any expressed or implied warranty.

----------------------------------------------------------------------------*/

#include "model.h"

model::model() { }

model::~model() { }


void model::e(INTEGER t)
{
  e_t(1,1)
    = data(t,2)
      - data(t,3)*s.theta(1,1)
      - data(t,4)*s.theta(2,1)
      - s.theta(4,1)*exp(data(t,5)*s.theta(3,1));
}

void model::dele(INTEGER t) 
{
  REAL    tmp;

  tmp = exp(data(t,5)*s.theta(3,1));

  dele_t(1,1) = - data(t,3);
  dele_t(1,2) = - data(t,4);
  dele_t(1,3) = - s.theta(4,1)*data(t,5)*tmp;
  dele_t(1,4) = - tmp;
}


int model::initialize()
{

  ifstream dataget("amstat.dat");
  if (!dataget) {
    cerr << "Error, model::model\n";
    exit(1);
  } 

  data.resize(30,5);

  double x;

  for (INTEGER i=1; i<=30; i++) {  
  for (INTEGER j=1; j<=5;  j++) {    
    dataget >> x; 
    data(i,j) = (REAL)x;
  }
  }

  if(strcmp(s.detail,"full")==0) cout <<starbox("/data//_")<< data;

  dataget.close();

  return 1;
}

void model::Z(INTEGER t)
{
  dele(t);
  for (INTEGER i = 1; i<=s.K; i++)
    if (i <= s.p) 
      Z_t[i] = dele_t[i];  // will produce SUR estimates when s.K = s.p 
    else 
      Z_t[i]=(REAL)pow((double)data(t,5),(int)(i-s.p));
}

int model::terminate() { return 0; }



